from debputy.deb_packaging_support import apply_compression
from debputy.filesystem_scan import build_virtual_fs
from debputy.plugin.api.test_api import virtual_path
from tutil import faked_binary_package


def test_apply_compression():
    dctrl_main_doc = faked_binary_package("foo")
    fs_root = build_virtual_fs(
        [
            virtual_path(
                "./usr/share/man/man1/foo.1",
                materialized_content="manpage content",
            ),
            virtual_path("./usr/share/man/man1/bar.1", link_target="foo.1"),
            virtual_path(
                "./usr/share/man/de/man1/bar.1", link_target="../../man1/foo.1"
            ),
        ],
        read_write_fs=True,
    )
    apply_compression(
        dctrl_main_doc,
        dctrl_main_doc,
        fs_root,
    )

    assert fs_root.lookup("./usr/share/man/man1/foo.1") is None
    assert fs_root.lookup("./usr/share/man/man1/foo.1.gz") is not None
    assert fs_root.lookup("./usr/share/man/man1/bar.1") is None
    bar_symlink = fs_root.lookup("./usr/share/man/man1/bar.1.gz")
    assert bar_symlink is not None
    assert bar_symlink.readlink() == "foo.1.gz"

    assert fs_root.lookup("./usr/share/man/de/man1/bar.1") is None
    de_bar_symlink = fs_root.lookup("./usr/share/man/de/man1/bar.1.gz")
    assert de_bar_symlink is not None
    assert de_bar_symlink.readlink() == "../../man1/foo.1.gz"
